# Can, optionaly, be define at build time (see README.RPM)
# - ocstag    : administrative tag
# - ocsserver : OCS Inventory NG communication serveur

Name:      ocsinventory-agent
Summary:   Open Computer and Software Inventory Next Generation client

Version:   2.0.4
Release:   21%{?dist}%{?ocstag:.%{ocstag}}

# Source0:   http://launchpad.net/ocsinventory-unix-agent/stable-2.0/2.0/+download/Ocsinventory-Agent-2.0.tar.gz
Source0:	ocsinventory-agent-%{version}.tar.gz

Source1:   %{name}.logrotate
Source2:   %{name}.cron

Source11:   %{name}.README
Source12:   %{name}.README.fr

Source1001: CernExtensionLinux.v2.pm
Source1002: %{name}.logrotate.cern

# Patch1:    %{name}-options.patch
Patch1001: cernextension-agent-2.0-01.patch
Patch1002: CernFixHostnameAndDeviceid.patch

Group:     Applications/System
License:   GPLv2+
Vendor:    CERN
Packager:  Linux.Support@cern.ch
URL:       http://www.ocsinventory-ng.org/

BuildArch: noarch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%if 0%{?rhel} != 3
BuildRequires: perl-Module-Install
%endif
BuildRequires: perl(XML::Simple) perl(LWP) perl(Net::IP)
BuildRequires: perl(Digest::MD5) perl(File::Temp)

Requires:  perl(:MODULE_COMPAT_%(eval "`%{__perl} -V:version`"; echo $version))
Requires:  net-tools, pciutils
Requires:  %{_sysconfdir}/logrotate.d, %{_sysconfdir}/cron.hourly
Requires:  perl(HTTP::Request)
Requires:  perl(Data::UUID)
Requires:  perl(Net::SSLeay) perl(Crypt::SSLeay) perl(Net::IP)
# Requires:  nmap monitor-edid which
Requires:  monitor-edid which
%if 0%{?rhel} == 3
Requires:  perl(XML::Parser)
%else
Requires:  perl(Proc::Daemon)
%endif
%if 0%{?rhel}%{?fedora} <= 4
Requires:  kernel-utils
%else
Requires:  smartmontools
%endif
# Optionnal : dmidecode on x86, /proc in ppc
# Requires:  %{_sbindir}/dmidecode
# Optionnal : ipdiscover or nmap, monitor-edid
# Requires: ocsinventory-ipdiscover, nmap, monitor-edid, bridge-utils
Obsoletes: ocsinventory-client <= 1.01
Provides:  ocsinventory-client  = 1.02
# use the following line when version is strictly above 1.01
# ocsinventory-client = %{version}-%{release}

%if 0%{?rhel} == 3
%define perl_vendorlib  %(eval "`%{__perl} -V:installvendorlib`"; echo $installvendorlib)
%endif

%description
Open Computer and Software Inventory Next Generation is an application
designed to help a network or system administrator keep track of computer
configuration and software installed on the network. 

It also allows deploying softwares, commands or files on Windows and 
Linux client computers.

%{name} provides the client for Linux (Unified Unix Agent).


%description -l fr
Open Computer and Software Inventory Next Generation est une application
destinée à aider l'administrateur système ou réseau à garder un oeil sur
la configuration des machines du réseau et sur les logiciels qui y sont
installés. 

Elle autorise aussi la télédiffusion (ou déploiement) de logiciels, 
de commandes ou de fichiers sur les clients Windows ou Linux.

%{name} fournit le client pour Linux (Agent Unix Unifié)


%prep
%setup -q -n ocsinventory-agent-%{version}

# %patch1 -p1
%patch1001 -p1
%patch1002 -p1

chmod -x lib/Ocsinventory/Agent/Backend/OS/MacOS/Hostname.pm

cat <<EOF >%{name}.conf
# 
# OCS Inventory "Unix Unified Agent" Configuration File
# used by hourly cron job
#

# Add tools directory if needed (tw_cli, hpacucli, ipssend, ...)
PATH=/sbin:/bin:/usr/sbin:/usr/bin

%if 0%{?ocsserver:1}
# Mode, change to "none" to disable
OCSMODE[0]=cron

%else
# Mode, change to "cron" to activate
OCSMODE[0]=none

%endif

# can be used to override the %{name}.cfg setup.
# OCSSERVER[0]=your.ocsserver.name
# 
# corresponds with --local=%{_localstatedir}/lib/%{name}
# OCSSERVER[0]=local

# Wait before inventory 
OCSPAUSE[0]=100

# Administrative TAG (optional, must be filed before first inventory)
OCSTAG[0]=%{?ocstag}
EOF

cat <<EOF >%{name}.cfg
# 
# OCS Inventory "Unix Unified Agent" Configuration File
#
# options used by cron job overides this (see /etc/sysconfig/%{name})
#

%if 0%{?ocsserver:1}
server = http://%{ocsserver}/ocsinventory
%else
# Server URL, unconmment if needed
# server = your.ocsserver.name
#local = %{_localstatedir}/lib/%{name}
%endif

# Administrative TAG (optional, must be filed before first inventory)
# tag = your_tag

# How to log, can be File,Stderr,Syslog
logger = Stderr
logfile = %{_localstatedir}/log/%{name}/%{name}.log
EOF

cp %{SOURCE11} README.RPM
cp %{SOURCE12} README.RPM.fr
cp %{SOURCE1001} lib/Ocsinventory/Agent/Backend/OS/Linux/CernExtension.pm



%build
%{__perl} Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}


%install
rm -rf %{buildroot}

make pure_install PERL_INSTALL_ROOT=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -type d -depth -exec rmdir {} 2>/dev/null ';'

chmod -R u+rwX,go+rX,go-w %{buildroot}/*

# Move exe to root directory
mv %{buildroot}%{_bindir} %{buildroot}%{_sbindir}

%{__mkdir_p} %{buildroot}%{_localstatedir}/{log,lib}/%{name}
%{__mkdir_p} %{buildroot}%{_sysconfdir}/{logrotate.d,sysconfig,cron.hourly,ocsinventory}

%{__install} -pm 644 %{SOURCE1002}   %{buildroot}%{_sysconfdir}/logrotate.d/%{name}
%{__install} -m 644 %{name}.conf %{buildroot}%{_sysconfdir}/sysconfig/%{name}

sed -e 's;/etc/;%{_sysconfdir}/;' \
    -e 's;/var/;%{_localstatedir}/;' \
    -e 's;/usr/sbin/;%{_sbindir}/;' \
    %{SOURCE2} > %{buildroot}%{_sysconfdir}/cron.hourly/%{name}
chmod +x %{buildroot}%{_sysconfdir}/cron.hourly/%{name}

%{__install} -m 644 %{name}.cfg %{buildroot}%{_sysconfdir}/ocsinventory/%{name}.cfg
%{__install} -m 644 etc/ocsinventory-agent/modules.conf %{buildroot}%{_sysconfdir}/ocsinventory/modules.conf

# Remove some unusefull files (which brings unresolvable deps)
rm -rf %{buildroot}%{perl_vendorlib}/Ocsinventory/Agent/Backend/OS/Win32*

# Remove collectors we do not intend to use at CERN
rm %{buildroot}%{perl_vendorlib}/Ocsinventory/Agent/Backend/OS/Generic/Users.pm
rm %{buildroot}%{perl_vendorlib}/Ocsinventory/Agent/Backend/OS/Generic/Processes.pm
rm -rf %{buildroot}%{perl_vendorlib}/Ocsinventory/Agent/Backend/IpDiscover/
rm %{buildroot}%{perl_vendorlib}/Ocsinventory/Agent/Backend/IpDiscover.pm
rm %{buildroot}%{_sbindir}/ipdiscover
# Only need for manual installation
rm %{buildroot}%{perl_vendorlib}/Ocsinventory/Unix/postinst.pl


%clean
#rm -rf %{buildroot}


%files
%defattr(-, root, root, -)
%doc AUTHORS Changes LICENSE README THANKS README.RPM
%lang(fr) %doc README.RPM.fr
%{perl_vendorlib}/Ocsinventory
%{_sbindir}/%{name}
%dir %{_localstatedir}/log/%{name}
%dir %{_localstatedir}/lib/%{name}
%dir %{_sysconfdir}/ocsinventory
%config(noreplace) %{_sysconfdir}/sysconfig/%{name}
%config(noreplace) %{_sysconfdir}/ocsinventory/%{name}.cfg
%config(noreplace) %{_sysconfdir}/ocsinventory/modules.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%{_sysconfdir}/cron.hourly/%{name}
%{_mandir}/man1/%{name}*
%{_mandir}/man3/Ocs*


%changelog
* Fri Jul 11 2014 Jaroslaw Polok <jaroslaw.polok@cern.ch>
- el7 rebuild

* Wed Jul 17 2013 Matthias Schroder <Matthias.Schroder@cern.ch> 2.0.4-21%{dist}
- Work around https://bugzilla.redhat.com/show_bug.cgi?id=985285

* Tue Jul 16 2013 Matthias Schroder <Matthias.Schroder@cern.ch> 2.0.4-20%{dist}
- Fix hostname for nodes using DHCP (avoid pb-d-...)

* Fri May  4 2012 Andreas Xenos <Andreas.Xenos@cern.ch> 2.0.4-7%{dist}
- Add stuff for cernspecialfiles (for now mainly licence information)

* Tue Apr 10 2012 Matthias Schroder <Matthias.Schroder@cern.ch> 2.0.4-5%{dist}
- Rebase on 2.0.4 tarball from launchpad, simplify built process

* Wed Jul 13 2011 Svetoslav Zhelev <Svetoslav.Zhelev.ch> 2.0-5%{dist}
- improve cernextension - do not break on missing SOAP::Lite

* Wed Jun 22 2011 Svetoslav Zhelev <Svetoslav.Zhelev.ch> 2.0-4%{dist}
- add location info to cernextension

* Tue May 24 2011 Matthias Schroder <Matthias.Schroder@cern.ch> 2.0-3%{dist}
- remove ipdiscover files from files section

* Tue May 24 2011 Svetoslav Zhelev <Svetoslav.Zhelev.ch> 2.0-2%{dist}
- modify agent config file

* Fri May 18 2011 Svetoslav Zhelev <Svetoslav.Zhelev.ch> 2.0-1%{dist}
- add CERN extension

* Mon Apr 08 2011 Svetoslav Zhelev <Svetoslav.Zhelev.ch> 2.0rc3-2%{dist}
- add CERN specific changes

* Mon Apr 04 2011 Matthias Schroder <Matthias.Schroder@cern.ch> 2.0rc3-1%{dist}
- Use 2.0rc3 tar file

* Mon Mar 21 2011 Svetoslav Zhelev <Svetoslav.Zhelev.ch> 1.1.2.1-7%{dist}
- CernExtension: Use the logger instead of dying
- CernExtension: Get OCS configuration path through OCS config object

* Tue Mar 08 2011 Matthias Schroder <Matthias.Schroder@cern.ch> 1.1.2.1-6%{dist}
- Remove Ocsinventory/Agent/Backend/IpDiscover/ to avoid bad surprises
- Drop requirement for nmap
- CernExtension: Trim the architecture

* Tue Mar 01 2011 Matthias Schroder <Matthias.Schroder@cern.ch> 1.1.2.1-5%{dist}
- Use cern source for logrotate config

* Fri Feb 04 2011 Matthias Schroder <Matthias.Schroder@cern.ch> 1.1.2.1-4%{dist}
- Remove Ocsinventory/Agent/Backend/OS/Generic/Users.pm and Processes.pm
- Change logrotate to weekly, keep 9 

* Tue Jan 11 2011 Svetoslav Zhelev <Svetoslav.Zhelev.ch> 1.1.2.1-2%{dist}
- Add CERN specific extensions

* Tue Nov 30 2010 Matthias Schroder <Matthias.Schroder@cern.ch> 1.1.2.1-1%{dist}
- Modify spec file to avoid getting kernel-utils required for .%{dist}

* Wed Oct 13 2010 Remi Collet <Fedora@famillecollet.com> 1.1.2.1-1
- security update for CVE-2009-0667
  http://bugs.debian.org/590879
  http://www.debian.org/security/2009/dsa-1828

* Sat Oct 09 2010 Remi Collet <Fedora@famillecollet.com> 1.1.2-2
- remove perl-XML-SAX optional dep, which is broken on EL5
  and cause overload when installed on the OCS server

* Sun Jan 03 2010 Remi Collet <Fedora@famillecollet.com> 1.1.2-1
- update to 1.1.2
- missing perl(Net::IP) requires (+ some EL3 stuff: yes, I know)

* Tue Dec 22 2009 Remi Collet <Fedora@famillecollet.com> 1.1.1-1
- update to 1.1.1

* Sat Nov 28 2009 Remi Collet <Fedora@famillecollet.com> 1.1-2
- add Requires: which

* Sat Nov 07 2009 Remi Collet <Fedora@famillecollet.com> 1.1-1
- update to 1.1
- add missing modules.conf
- new Requires perl(Net::SSLeay), perl(Crypt::SSLeay), smartmontools
- download URL to launchpad

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.1-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu May 14 2009 Remi Collet <Fedora@famillecollet.com> 1.0.1-4
- fix typo

* Thu May 14 2009 Remi Collet <Fedora@famillecollet.com> 1.0.1-3
- define PATH in config (workaround for #500594 + tool path if needed)
 
* Fri Apr 24 2009 Remi Collet <Fedora@famillecollet.com> 1.0.1-2
- update the README.RPM (new configuration file)
- change from URL to only servername in config comment

* Sun Mar 29 2009 Remi Collet <Fedora@famillecollet.com> 1.0.1-1
- update to 1.0.1

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.0.9.2-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Oct 20 2008 Remi Collet <Fedora@famillecollet.com> 0.0.9.2-2
- fix FTBFS (#465073)

* Sun Apr 20 2008 Remi Collet <Fedora@famillecollet.com> 0.0.9.2-1
- update to 0.0.9.2 (minor bug fix)

* Mon Apr 07 2008 Remi Collet <Fedora@famillecollet.com> 0.0.9.1-2
- add Requires monitor-edid

* Thu Apr 03 2008 Remi Collet <Fedora@famillecollet.com> 0.0.9.1-1
- update to 0.0.9.1 (minor bug fix)
- swicth back to nobundle sources

* Wed Apr 02 2008 Remi Collet <Fedora@famillecollet.com> 0.0.9-1
- update to 0.0.9 finale
- provides default config to file (need options.patch)
- add requires nmap (for ipdiscover)
- add BR perl(XML::SAX) (to avoid install of bundled one)

* Mon Mar 10 2008 Remi Collet <Fedora@famillecollet.com> 0.0.8.2-0.6.20080305
- rebuild against perl 5.10

* Fri Mar  7 2008 Remi Collet <Fedora@famillecollet.com> 0.0.8.2-0.5.20080305
- patches from review (Patrice Dumas)

* Wed Mar  5 2008 Remi Collet <Fedora@famillecollet.com> 0.0.8.2-0.4.20080305
- update to 2008-03-05
- add /etc/sysconfig/ocsinventory-agent config file for cron job

* Mon Mar  3 2008 Remi Collet <Fedora@famillecollet.com> 0.0.8.2-0.3.20080302
- only enable cron when server is configured

* Sun Mar  2 2008 Remi Collet <Fedora@famillecollet.com> 0.0.8.2-0.2.20080302
- from Review, see #435593

* Sun Mar  2 2008 Remi Collet <Fedora@famillecollet.com> 0.0.8.2-0.1.20080302
- update to 0.0.8.2 from CVS

* Fri Feb 22 2008 Remi Collet <Fedora@famillecollet.com> 0.0.8.2-0.1.20080222
- update to 0.0.8.2 from CVS

* Sun Feb 17 2008 Remi Collet <Fedora@famillecollet.com> 0.0.8.1-0.1.20080217
- update to 0.0.8.1 from CVS
- change config file used
   from /etc/ocsinventory-agent/ocsinv.conf 
     to /etc/ocsinventory/ocsinventory-agent.cfg

* Sat Jan 26 2008 Remi Collet <Fedora@famillecollet.com> 0.0.7-1
- update to 0.0.7

* Sat Dec 28 2007 Remi Collet <Fedora@famillecollet.com> 0.0.6.2-1
- update to 0.0.6.2

* Mon Apr 16 2007 Remi Collet <Fedora@famillecollet.com> 0.0.6-1
- update to 0.0.6

* Sat Feb 10 2007 Remi Collet <Fedora@famillecollet.com> 0.0.5-0.20070409
- cvs update 20070409
- create cron.daily file
- create logrotate.d file
- create ocsinv.conf
- cvs update 20070405
- cvs update 20070403

* Sat Feb 10 2007 Remi Collet <Fedora@famillecollet.com> 0.0.2-0.20070210
- initial spec
